Subject: [Netconf] draft-ietf-netconf-nmda-netconf review

From: Mahesh Jethanandani <[email-masked]>
Date: Tue, 15 May 2018 10:36:16 +0200

A quick review of the draft has revealed the following issue and question.

1. A run of pyang on the model reveals the following:

> pyang --ietf [email-masked] 
[email-masked]:205: warning: RFC 6087: 4.10,4.12: statement "enum" should have a "description” substatement

2. This is a follow-up to the discussion on the mailing list. Reading through this draft, RFC7950, RFC6020, and rfc7895bis, it is not clear if a NETCONF server that wants to support both YANG 1.0 and YANG 1.1, needs to do from a schema advertisement perspective. Does it advertise the schemas as part of <hello> and as part of yang-library:1.1? Does it advertise both YANG 1.0 and 1.1 models in both the modes?

Mahesh Jethanandani // as shepherd

---

From: Juergen Schoenwaelder <[email-masked]>
Date: Tue, 15 May 2018 11:42:42 +0200

> 2. This is a follow-up to the discussion on the mailing list. Reading through this draft, RFC7950, RFC6020, and rfc7895bis, it is not clear if a NETCONF server that wants to support both YANG 1.0 a…

How does this relate to NMDA?

/js

-- 
Juergen Schoenwaelder           Jacobs University Bremen gGmbH
Phone: +49 421 200 3587         Campus Ring 1 | 28759 Bremen | Germany
Fax:   +49 421 200 3103         <https://www.jacobs-university.de/>

---

From: Mahesh Jethanandani <[email-masked]>
Date: Tue, 15 May 2018 13:14:12 +0200

> On May 15, 2018, at 11:42 AM, Juergen Schoenwaelder <[email-masked]> wrote:
> 

If we agree this needs to be clarified, we can decide next where to put the clarification.

> /js

Mahesh Jethanandani
[email-masked]

---

From: Juergen Schoenwaelder <[email-masked]>
Date: Tue, 15 May 2018 13:30:36 +0200

> If we agree this needs to be clarified, we can decide next where to put the clarification.

Well you raised this in a thread concerning nmda-netconf. We currently
have this:

   An NMDA-compliant NETCONF server MUST support the operational state
   datastore and it MUST implement at least revision 201X-XX-XX of the
   "ietf-yang-library" module defined in [I-D.ietf-netconf-rfc7895bis].

So for NMDA, implementations have to use "ietf-yang-library".

So what are the proposed edits that relate to NMDA?

/js

---

From: Robert Wilton <[email-masked]>
Date: Tue, 15 May 2018 14:14:47 +0100

Hi Mahesh,

> 2. This is a follow-up to the discussion on the mailing list. Reading through this draft, RFC7950, RFC6020, and rfc7895bis, it is not clear if a NETCONF server that wants to support both YANG 1.0 a…
It is the specific modules that are being supported that are YANG 
1.0/YANG 1.1 rather than the NETCONF server generically.

So, I think that this is really a variant of the broader question: Can a 
device implement multiple revisions of a YANG module?  This seems like a 
question that may be appropriate to be considered by the YANG versioning DT.

But my recollection of the current RFCs (and YANG library bis draft) is 
that a standards compliant server only advertises a single revision of a 
module, and hence supporting multiple revisions is beyond the scope of 
the current standards documents.

Thanks,
Rob

> _______________________________________________
> Netconf mailing list
> [email-masked]
> https://www.ietf.org/mailman/listinfo/netconf

---

From: Mahesh Jethanandani <[email-masked]>
Date: Wed, 16 May 2018 08:02:40 +0200

Let me take this up in a separate thread that is not tied to this review.

In the meantime, can we address the pyang error.

> On May 15, 2018, at 1:30 PM, Juergen Schoenwaelder <[email-masked]> wrote:
> 

Mahesh Jethanandani
[email-masked]

---

From: Martin Bjorklund <[email-masked]>
Date: Wed, 16 May 2018 08:08:10 +0200 (CEST)

Hi,

> Let me take this up in a separate thread that is not tied to this review.

Ok.

> In the meantime, can we address the pyang error.

It is not an error, but a warning.  This enum value is described in
the description for the leaf, so I think the current text is fine.

/martin

---

From: Rohit R Ranade <[email-masked]>
Date: Wed, 16 May 2018 06:38:33 +0000

Hi,

I still feel that the examples need to show more information. We have added to filter mechanism and also the with-origin parameter. But there is no example to show its usage. 
An example showing that query output MAY contain origins which user may not desire, for example Device having a configuration with parent belonging to intended origin and child leaf belonging to system origin and user gives negated filter to avoid intended (in such cases, both parent and child will be part of output). As mentioned by Juergen, it is intention of the draft to output the leaf which match the filter condition.

With Regards,
Rohit R Ranade

-----Original Message-----
From: Netconf [mailto:[email-masked]] On Behalf Of Martin Bjorklund
Sent: 16 May 2018 11:38
To: [email-masked]
Cc: [email-masked]
Subject: Re: [Netconf] draft-ietf-netconf-nmda-netconf review

Hi,

Ok.

> In the meantime, can we address the pyang error.

It is not an error, but a warning.  This enum value is described in the description for the leaf, so I think the current text is fine.

/martin

> > Well you raised this in a thread concerning nmda-netconf. We 
> > currently have this:
> >

---

From: Qin Wu <[email-masked]>
Date: Wed, 16 May 2018 07:48:53 +0000

-----邮件原件-----
发件人: Netconf [mailto:[email-masked]] 代表 Robert Wilton
发送时间: 2018年5月15日 21:15
收件人: Mahesh Jethanandani; Netconf
主题: Re: [Netconf] draft-ietf-netconf-nmda-netconf review

Hi Mahesh,

On 15/05/2018 09:36, Mahesh Jethanandani wrote:
> [email-masked]:205: warning: RFC 6087: 4.10,4.12: 
> statement "enum" should have a "description” substatement
>
It is the specific modules that are being supported that are YANG 1.0/YANG 1.1 rather than the NETCONF server generically.

So, I think that this is really a variant of the broader question: Can a device implement multiple revisions of a YANG module?  This seems like a question that may be appropriate to be considered by the YANG versioning DT.

[Qin]: Good point, suppose we have two revisions of a YANG module, one revision is not back-compatible to another, would it be great for device to implement both revisions, but we may also require some fall back mechanism or update mechanism to inform the client some revision of the module is not supported.

But my recollection of the current RFCs (and YANG library bis draft) is that a standards compliant server only advertises a single revision of a module, and hence supporting multiple revisions is beyond the scope of the current standards documents.

Thanks,
Rob

---

From: Juergen Schoenwaelder <[email-masked]>
Date: Wed, 16 May 2018 09:55:27 +0200

> [Qin]: Good point, suppose we have two revisions of a YANG module, one revision is not back-compatible to another, would it be great for device to implement both revisions, but we may also require…

The YANG versioning model requires that modules are backwards compatible.
Again, this has nothing to do with NMDA (this is the wrong thread).

/js

---

From: Martin Bjorklund <[email-masked]>
Date: Mon, 28 May 2018 08:31:38 +0200 (CEST)

Hi,

Version -06 is now posted.  It addresses the warning re the "enum"
statement.

/martin